c     Program za generiranje mreze trikotnikov po metodi Advancing front
      INCLUDE 'af_pp.f'
      PROGRAM af
      INCLUDE 'phigsdef.f'

      REAL f0x(5000), f0y(5000), fx(1000), fy(1000),
     *     xks(2), yks(2), x(2), y(2), okx(5), oky(5)
      REAL WindowLimits(4), ViewMappingMatrix(3,3)
      REAL ViewportLimits(4) /0.0, 1.0, 0.0, 1.0/
      INTEGER ng, wkid, ErrorReturn
      REAL f0(5000,2), f(1000,2), ft(4000,2), fg(12000,2) 
      INTEGER nz(20), nk(20) 
      REAL xmin, xmax, ymin, ymax, dmax, xt, yt, kxy, dt, dt1, v
      INTEGER n0, n, n_cel, ot, n_ft, n_fg, m, i_nt, i, j, k
      OPEN (10,FILE='pod.txt')
      OPEN (20,FILE='rez.txt')
      
c     Branje podatkov (zeljene dolzine segmentov, faktorja raztegnitve
c     mreze, stevila tock ograje in podane ograje obmocja) 
c     in dolocitev velikosti danega obmocja
      READ (10,10) dt, kxy, n0
   10 FORMAT (/F12.5//F12.5//I10///)                                           
      READ(10,*) (f0(1,j),j=1,2)
      xmin = f0(1,1)
      xmax = f0(1,1)
      ymin = f0(1,2)
      ymax = f0(1,2)
      f0(1,2) = kxy*f0(1,2)
      DO k=2,n0 
          READ(10,*) (f0(k,j),j=1,2)
          IF (f0(k,1).LT.xmin) xmin = f0(k,1)
          IF (f0(k,1).GT.xmax) xmax = f0(k,1)
          IF (f0(k,2).LT.ymin) ymin = f0(k,2)
          IF (f0(k,2).GT.ymax) ymax = f0(k,2)
          f0(k,2) = kxy*f0(k,2)
      END DO
      dmax = xmax-xmin
      IF (1.1*(ymax-ymin).GT.dmax) dmax = 1.1*(ymax-ymin)
      
c     Diskretizacija ograje 
      CALL diskr(f0, n0, f, n, ot, dt)
      n_cel = n+1
      DO k=1,n0
          f0x(k) = f0(k,1)
          f0y(k) = f0(k,2)/kxy
      END DO
      DO k=1,n_cel
          fx(k) = f(k,1)
          fy(k) = f(k,2)/kxy
      END DO
      ng = n_cel
      
c     Zapis tock ograje v spremenljivko, ki bo vsebovala vse nastale 
c     tocke obmocja
      n_ft = n_cel-1
      DO j=1,n_ft
          ft(j,1) = f(j,1)
          ft(j,2) = f(j,2)/kxy
      END DO
      n_fg = 0
      
c     Dolocitev zacetnih vrednosti spremenljivk, ki dolocajo meje 
c     posameznih podobmocij 
      m = 1
      nz(m) = 1
      nk(m) = n_cel

      i = 1
      DO WHILE (m.NE.0)
          
c     Dolocitev nove tocke, ki predstavlja vrh novega trikotnika      
          CALL nt(f(i,1), f(i,2), f(i+1,1), f(i+1,2), ot, 
     *            dt, xt, yt, dt1, v)  
                                                                
c     Kontrola okolice novega trikotnika in morebitna izbira ze 
c     obstojece tocke za vrh trikotnika                                                      
          CALL nov_tr(i, f, nz(m), nk(m), xt, yt, dt1, v, i_nt)
            
c     Dopolnitev mreze in spremenljivk, ki vsebujejo novo nastale
c     tocke in daljice 
          CALL adv_f(kxy, i, f, n_cel, nz, nk, m, xt, yt, i_nt, 
     *               ft, n_ft, fg, n_fg)
      END DO

c     Inicializacija graficne knjiznice in definicija izhodne
c     naprave
      CALL popph(1, 0)
      wkid = 1
      CALL popwk(wkid, "", WK171024)
      WindowLimits(1) = (xmin+xmax-1.1*dmax)/2
      WindowLimits(2) = (xmin+xmax+1.1*dmax)/2
      WindowLimits(3) = (ymin+ymax-0.93*1.1*dmax)/2
      WindowLimits(4) = (ymin+ymax+1.07*1.1*dmax)/2
      CALL pevmm(WindowLimits, ViewportLimits,
     *           ErrorReturn, ViewMappingMatrix)
      CALL pswkw(wkid, 0.0, 1.0, 0.0, 1.0)
      CALL pswkv(wkid, 0.0, 0.2, 0.0, 0.2)

c     Nastavitve in izris okvirja
      CALL psplci(6)
      okx(1) = (xmin+xmax-0.96*1.1*dmax)/2
      okx(2) = (xmin+xmax+0.96*1.1*dmax)/2
      okx(3) = (xmin+xmax+0.96*1.1*dmax)/2
      okx(4) = (xmin+xmax-0.96*1.1*dmax)/2
      okx(5) = (xmin+xmax-0.96*1.1*dmax)/2
      oky(1) = (ymin+ymax-0.89*1.1*dmax)/2
      oky(2) = (ymin+ymax-0.89*1.1*dmax)/2
      oky(3) = (ymin+ymax+1.03*1.1*dmax)/2
      oky(4) = (ymin+ymax+1.03*1.1*dmax)/2
      oky(5) = (ymin+ymax-0.89*1.1*dmax)/2
      CALL ppl(5, okx, oky)

c     Nastavitve in izris teksta
      CALL pstxci(5)
      CALL pschh(0.007)
      CALL pstxal(PACENT, 0)
      CALL ptx((xmin+xmax)/2, (ymin+ymax+1.1*dmax)/2,
     *         'GENERIRANJE MREZE PO METODI ADVANCING FRONT')

c     Nastavitve in izris ograje danega obmocja ter mreze
c     trikotnikov
      CALL psplci(5)
      CALL ppl(n0, f0x, f0y)
      CALL psplci(4)
      CALL ppl(ng, fx, fy)
      DO i=1,n_fg-1,2
          x(1) = fg(i,1)
          x(2) = fg(i+1,1)
          y(1) = fg(i,2)
          y(2) = fg(i+1,2)
          CALL ppl(2, x, y)
      END DO

c     Nastavitve in izris koordinatnega sistema
      CALL psplci(2)
      xks(1) = (xmin+xmax-0.94*1.1*dmax)/2
      xks(2) = (xmin+xmax+0.94*1.1*dmax)/2
      yks(1) = 0.0
      yks(2) = 0.0
      CALL ppl(2, xks, yks)
      xks(1) = 0.0
      xks(2) = 0.0
      yks(1) = (ymin+ymax-0.87*1.1*dmax)/2
      yks(2) = (ymin+ymax+0.91*1.1*dmax)/2
      CALL ppl(2, xks, yks)

      CALL pstxci(2)
      CALL pschh(0.005)
      CALL pstxal(PARITE, 0)
      CALL ptx((xmin+xmax+0.94*1.1*dmax)/2, -0.005*1.1*dmax, 'X')
      CALL ptx(-0.005*1.1*dmax, (ymin+ymax+0.91*1.1*dmax)/2, 'Y')
      CALL ptx(-0.005*1.1*dmax, -0.005*1.1*dmax, '0')
                      
c     Izpis nastalih tock obmocja                 
      WRITE (20,*) 'Tocke obmocja:'
      WRITE (20,*) '   n      x           y'
      DO i=1,n_ft
           WRITE (20,20) i, (ft(i,j),j=1,2)  
   20      FORMAT (I5, 2F12.5)
      END DO
      CLOSE (10)
      CLOSE (20)

      PAUSE 

c     Zapiranje izhodne naprave in knjiznice
      CALL pclwk(wkid)
      CALL pclph()

      END                     
