c     Funkcija za izracun razdalje med dvema tockama
      REAL FUNCTION d(x, y)  
      
      REAL x, y
      d = SQRT(x**2+y**2)
      RETURN
      END


c     Podprogram za diskretizacijo in dolocitev orientacije dane ograje
      SUBROUTINE diskr(f0, n0, f, n, ot, dt)                           
      
      REAL f0(5000,2), f(1000,2)
      REAL dt, dol, dol_i, d_k, d_pod, d_l, s
      INTEGER n0, n, ot, j, k, l
      dol = 0
      DO k=1,n0-1
          dol = dol+d(f0(k+1,1)-f0(k,1), f0(k+1,2)-f0(k,2))
      END DO
      n = NINT(dol/dt)
      dol_i = dol/n
      DO j=1,2
          f(1,j) = f0(1,j)
          f(n+1,j) = f(1,j)
      END DO
      DO k=1,n-1
          d_k = k*dol_i
          d_pod = 0
          l = 1
          DO WHILE (d_pod.LT.d_k)
              d_pod = d_pod+d(f0(l+1,1)-f0(l,1), f0(l+1,2)-f0(l,2))
              l = l+1
          END DO
          d_l = d(f0(l,1)-f0(l-1,1), f0(l,2)-f0(l-1,2))
          DO j=1,2
              f(k+1,j) = f0(l,j)-(f0(l,j)-f0(l-1,j))*(d_pod-d_k)/d_l
          END DO
      END DO
      s = 0
      DO k=1,n
          s = s+f(k,1)*f(k+1,2)-f(k+1,1)*f(k,2)
      END DO
      ot = 0
      IF (s.LT.0) ot = 1
      RETURN
      END


c     Podprogram za dolocitev nove tocke, ki predstavlja vrh 
c     novega trikotnika   
      SUBROUTINE nt(x1, y1, x2, y2, ot, dt, xt, yt, dt1, v)
      
      REAL x1, y1, x2, y2, dt, xt, yt, dt1, ds, v
      INTEGER ot
      ds = d(x2-x1, y2-y1)
      IF (0.55*ds.GT.dt) THEN
          dt1 = 0.55*ds
      ELSE IF (2*ds.LT.dt) THEN
          dt1 = 2*ds
      ELSE
          dt1 = dt
      END IF
      v = SQRT(dt1**2-(ds/2)**2)
      xt = (x1+x2)/2+(-1)**ot*v*(y1-y2)/ds
      yt = (y1+y2)/2+(-1)**ot*v*(x2-x1)/ds
      RETURN
      END


c     Podprogram za izracun minimalne razdalje med tocko in daljico 
      SUBROUTINE min_r(x1, y1, x2, y2, a, b, t1, t2, mr)
                 
      REAL x1, y1, x2, y2, a, b, mr, t
      INTEGER t1, t2
      t1 = 0
      t2 = 0
      t = ((b-y1)*(y2-y1)+(a-x1)*(x2-x1))/((x2-x1)**2+(y2-y1)**2)
      IF (t.LE.0) THEN
          t1 = 1
          mr = d(x1-a, y1-b)
      ELSE IF (t.GE.1) THEN
          t2 = 1
          mr = d(x2-a, y2-b)
      ELSE
          mr = d(x1-a+t*(x2-x1), y1-b+t*(y2-y1))
      END IF
      RETURN
      END


c     Funkcija za kontrolo sekanja dveh daljic 
      INTEGER FUNCTION kontr(xi1, yi1, xi2, yi2, xj1, yj1, xj2, yj2)
      
      REAL xi1, yi1, xi2, yi2, xj1, yj1, xj2, yj2, s, s1, s2
      kontr = 0
      s = (xj2-xj1)*(yi2-yi1)-(xi2-xi1)*(yj2-yj1)
      s1 = (xj2-xj1)*(yj1-yi1)-(xj1-xi1)*(yj2-yj1)
      s2 = (xi2-xi1)*(yj1-yi1)-(xj1-xi1)*(yi2-yi1)
      IF (((s1.GE.0.AND.s1.LE.s).OR.(s1.LE.0.AND.s1.GE.s)).AND.
     *    ((s2.GE.0.AND.s2.LE.s).OR.(s2.LE.0.AND.s2.GE.s))) kontr = 1
      IF ((s1.EQ.0.OR.s1.EQ.s).AND.(s2.EQ.0.OR.s2.EQ.s)) kontr = 0
      RETURN
      END


c     Podprogram za kontrolo okolice novega trikotnika in morebitna 
c     izbira ze obstojece tocke za vrh trikotnika
      SUBROUTINE nov_tr(i, f, nz, nk, xt, yt, dt1, v, i_nt)
      
      REAL f(1000,2), rt(1000) ,rd(1000)                                   
      INTEGER rti(1000) ,rdi(1000)
      REAL xt, yt, dt1, v, s1, s2, dol, mr 
      INTEGER nz, nk, n_rt, n_rd, kon1, kon2, kon3, t1, t2, kt1, kt2,    
     *        kt, meja, ks, ks1, ks2, i_kt, i_nt, i, j, k, l 
     
c     Ureditev razdalj med novo tocko ter tockami in daljicami ograje
c     po velikosti
      n_rt = 0
      n_rd = 0
      kt1 = 0
      kt2 = 0
      s1 = (f(nz,1)-f(i,1))*(f(i,2)-f(i+1,2))+
     *     (f(nz,2)-f(i,2))*(f(i+1,1)-f(i,1))
      DO j=nz,nk-1
          s2 = (f(j+1,1)-f(i,1))*(f(i,2)-f(i+1,2))+
     *         (f(j+1,2)-f(i,2))*(f(i+1,1)-f(i,1))
          IF (j.NE.i) THEN
              IF (s1.GT.0.AND.j.NE.(i+1)) THEN
                  k = 1
                  dol = d(xt-f(j,1), yt-f(j,2))
                  DO WHILE (dol.GE.rt(k).AND.k.LE.n_rt)
                      k = k+1
                  END DO
                  n_rt = n_rt+1
                  DO l=n_rt,k+1,-1
                      rti(l) = rti(l-1)
                      rt(l) = rt(l-1)
                  END DO
                  rti(k) = j
                  rt(k) = dol
              END IF
              IF (s1.GT.0.OR.s2.GT.0) THEN
                  k = 1
                  CALL min_r(f(j,1), f(j,2), f(j+1,1), f(j+1,2), 
     *                       xt, yt, t1, t2, mr)
                  IF (j.EQ.(i-1).AND.t2.EQ.1) kt1 = 1
                  IF (j.EQ.(i+1).AND.t1.EQ.1) kt2 = 1
                  DO WHILE (mr.GE.rd(k).AND.k.LE.n_rd)
                      k = k+1
                  END DO
                  n_rd = n_rd+1
                  DO l=n_rd,k+1,-1
                      rdi(l) = rdi(l-1)
                      rd(l) = rd(l-1)
                  END DO
                  rdi(k) = j
                  rd(k) = mr
              END IF        
          END IF    
          s1 = s2
      END DO 
      
c     Dolocitev meje kontrole 
      meja = 1
      DO WHILE (rd(meja).LE.dt1.AND.meja.LE.n_rd)
          meja = meja+1
      END DO
      
c     Morebitna izbira ze obstojece tocke za vrh trikotnika in
c     kontrola sekanja novih daljic z ograjo
      kt = 0
      IF (rd(1).GE.v.AND.rt(1).GT.dt1) kt = 1           
      IF (kt.EQ.1.OR.(rdi(1).EQ.(i-1).AND.kt1.EQ.1).OR.
     *   (rdi(1).EQ.(i+1).AND.kt2.EQ.1)) THEN
          i_nt = 0
      ELSE
          ks = 1
          k = 1
          DO WHILE (ks.EQ.1.AND.k.LE.n_rt)
              i_nt = rti(k)
              IF (rt(k).GT.dt1) THEN
                  l = meja
                  DO WHILE (rd(l).LE.rt(k).AND.l.LE.n_rd)
                      l = l+1
                  END DO
                  meja = l
              END IF
              l = 1
              ks = 0
              DO WHILE (l.LT.meja.AND.ks.EQ.0)
                 i_kt = rdi(l)
                 kon1 = 0
                 kon2 = 0
                 kon3 = 0
                 IF (i_nt.EQ.i_kt.OR.i_nt.EQ.(i_kt+1).OR.
     *               (i_nt.EQ.nz.AND.(i_kt+1).EQ.nk)) kon1 = 1
                 IF ((i_kt+1).EQ.i.OR.(i.EQ.nz.AND.(i_kt+1).EQ.nk))
     *               kon2 = 1 
                 IF (i_kt.EQ.(i+1).OR.(i_kt.EQ.nz.AND.(i+1).EQ.nk))
     *               kon3 = 1
                 IF (kon1.EQ.0.AND.kon2.EQ.0)
     *             ks1 = kontr(f(i,1), f(i,2), f(i_nt,1), f(i_nt,2),
     *                   f(i_kt,1), f(i_kt,2), f(i_kt+1,1), f(i_kt+1,2))
                 IF (kon1.EQ.0.AND.kon3.EQ.0)
     *             ks2 = kontr(f(i+1,1), f(i+1,2), f(i_nt,1), f(i_nt,2),
     *                   f(i_kt,1), f(i_kt,2), f(i_kt+1,1), f(i_kt+1,2))
                 IF (ks1.EQ.1.OR.ks2.EQ.1) ks = 1
                 l = l+1
              END DO
              k = k+1
          END DO
          IF (ks.EQ.1) STOP 'Napaka pri generiranju mreze.'
      END IF
      RETURN
      END  


c     Podprogram za dopolnitev mreze in spremenljivk, ki vsebujejo 
c     novo nastale tocke in daljice        
      SUBROUTINE adv_f(kxy, i, f, n_cel, nz, nk, m, xt, yt, i_nt, 
     *                 ft, n_ft, fg, n_fg)
     
      REAL f(1000,2), f_st(1000,2), fp(1000,2), ft(4000,2), fg(12000,2) 
      INTEGER nz(20), nk(20) 
      REAL xt, yt, kxy
      INTEGER np, n_cel, n_st, n_ft, n_fg, m, m_st, 
     *        i_st, i_nt, meja, kon, i, j, k

      DO j=1,n_cel
          f_st(j,1) = f(j,1)
          f_st(j,2) = f(j,2)
      END DO
      i_st = i
      n_st = n_cel
      m_st = m 
      IF (i_nt.EQ.0) THEN

c     Dopolnitev mreze v primeru nove tocke trikotnika         
          n_cel = n_cel+1
          DO j=n_cel,i+2,-1
              f(j,1) = f(j-1,1)
              f(j,2) = f(j-1,2)
          END DO    
          f(i+1,1) = xt
          f(i+1,2) = yt
          nk(m) = n_cel
          i = i+2
          IF (i.EQ.n_cel) i = nz(m) 
      ELSE IF ((nk(m)-nz(m)).EQ.3) THEN

c     Dopolnitev v primeru zakljucka mreze na dolocenem podobmocju
          n_cel = n_cel-4
          m = m-1
          IF (m.NE.0) i = nz(m)+1
      ELSE 

c     Dopolnitev mreze v primeru izbire ze obstojece tocke za vrh
c     novega trikotnika      
          n_cel = n_cel+2
          np = nz(m)
          kon = 0
          k = i+1
          fp(1,1) = f(i_nt,1)
          fp(1,2) = f(i_nt,2)
          DO j=2,n_cel-np 
              IF (k.EQ.(n_cel-2)) k = nz(m)
              fp(j,1) = f(k,1)
              fp(j,2) = f(k,2)
              IF (k.EQ.i_nt.AND.kon.EQ.0) THEN
                  meja = j
                  kon = 1
              ELSE
                  k = k+1
              END IF
          END DO
          fp(n_cel-np+1,1) = f(i_nt,1)
          fp(n_cel-np+1,2) = f(i_nt,2)
          IF (meja.GT.3.AND.(n_cel-np-meja).GT.2) THEN 

c     Novo nastali trikotnik razdeli obmocje         
              m = m+1
              nk(m-1) = meja+np-1
              nz(m) = meja+np
              nk(m) = n_cel
              i = nz(m)
          ELSE

c     Za vrh novo nastalega trikotnika je izbrana sosednja tocka 
c     na ograji         
              n_cel = n_cel-3
              IF (meja.EQ.3) THEN
                  kon = 1
                  DO j=1,n_cel-np+1
                      fp(j,1) = fp(j+3,1)
                      fp(j,2) = fp(j+3,2)
                  END DO
                  i = np
              ELSE
                  kon = 0
                  i = np+1
              END IF
              nk(m) = n_cel
          END IF
          DO j=1,n_cel-np+1
              f(np-1+j,1) = fp(j,1)
              f(np-1+j,2) = fp(j,2)
          END DO
      END IF 
      
c     Zapis morebitnih novih tock in daljic obmocja     
      IF (m.GE.m_st) THEN
          IF (n_st.LT.n_cel) THEN
              n_fg = n_fg+4
              fg(n_fg-3,1) = f_st(i_st,1)
              fg(n_fg-3,2) = f_st(i_st,2)/kxy
              fg(n_fg-1,1) = f_st(i_st+1,1)
              fg(n_fg-1,2) = f_st(i_st+1,2)/kxy
              IF (i_nt.EQ.0) THEN
                  n_ft = n_ft+1
                  ft(n_ft,1) = xt
                  ft(n_ft,2) = yt/kxy
                  fg(n_fg-2,1) = xt
                  fg(n_fg-2,2) = yt/kxy
              ELSE
                  fg(n_fg-2,1) = f_st(i_nt,1)
                  fg(n_fg-2,2) = f_st(i_nt,2)/kxy
              END IF
              fg(n_fg,1) = fg(n_fg-2,1)
              fg(n_fg,2) = fg(n_fg-2,2)
          ELSE
              n_fg = n_fg+2
              IF (kon.EQ.0) THEN
                  fg(n_fg-1,1) = f_st(i_st+1,1)
                  fg(n_fg-1,2) = f_st(i_st+1,2)/kxy
              ELSE
                  fg(n_fg-1,1) = f_st(i_st,1)
                  fg(n_fg-1,2) = f_st(i_st,2)/kxy
              END IF   
              fg(n_fg,1) = f_st(i_nt,1)
              fg(n_fg,2) = f_st(i_nt,2)/kxy
          END IF
      END IF
      RETURN
      END     
